#!/usr/bin/env python
# mypy: disable-error-code="no-untyped-def, has-type, misc"
# no-untyped-def: need to learn about typing.Generator return type for create_eeps
# has-type, misc: look later. They occur when comparing pytest.eeps values in asserts

"""Tests for `ska_low_mccs_calibration.eep`."""

import os
from typing import List, Union

import numpy
import numpy.typing as npt
import pytest
from numpy import random

from ska_low_mccs_calibration.eep import (
    get_nearest_file,
    load_eeps,
    normalise_eeps,
    resample_eeps,
    station_rotation_matrix,
)


def save_eeps_npy(
    cwd: str, eeps: list[npt.NDArray[Union[numpy.complex64, numpy.complex128]]]
) -> List[str]:
    """Save EEPs in npy format."""
    [eep_x_phi, eep_x_theta, eep_y_phi, eep_y_theta] = eeps
    fname_x_phi = f"{cwd}/../testing_data/tmp_120MHz_Xpol_phi.npy"
    fname_x_theta = f"{cwd}/../testing_data/tmp_120MHz_Xpol_theta.npy"
    fname_y_phi = f"{cwd}/../testing_data/tmp_120MHz_Ypol_phi.npy"
    fname_y_theta = f"{cwd}/../testing_data/tmp_120MHz_Ypol_theta.npy"

    numpy.save(fname_x_phi, eep_x_phi.astype(numpy.complex64))
    numpy.save(fname_x_theta, eep_x_theta.astype(numpy.complex64))
    numpy.save(fname_y_phi, eep_y_phi.astype(numpy.complex64))
    numpy.save(fname_y_theta, eep_y_theta.astype(numpy.complex64))
    return [fname_x_phi, fname_x_theta, fname_y_phi, fname_y_theta]


def save_eeps_npz(
    cwd: str,
    eeps: list[npt.NDArray[Union[numpy.complex64, numpy.complex128]]],
    postbase: str = "",
) -> List[str]:
    """Save EEPs in npz format."""
    [eep_x_phi, eep_x_theta, eep_y_phi, eep_y_theta] = eeps
    fname_x = f"{cwd}/../testing_data/tmp{postbase}_120MHz_Xpol.npz"
    fname_y = f"{cwd}/../testing_data/tmp{postbase}_120MHz_Ypol.npz"
    numpy.savez(
        fname_x,
        Ephi=eep_x_phi.astype(numpy.complex64),
        Etheta=eep_x_theta.astype(numpy.complex64),
    )

    numpy.savez(
        fname_y,
        Ephi=eep_y_phi.astype(numpy.complex64),
        Etheta=eep_y_theta.astype(numpy.complex64),
    )
    return [fname_x, fname_y]


def save_eeps(eeps) -> list[str]:
    """Save the EEP image files into all the needed formats."""
    cwd = os.path.dirname(os.path.realpath(__file__))

    names_npy = save_eeps_npy(cwd, eeps)
    names_npz = save_eeps_npz(cwd, eeps)

    ave_eeps = []
    for eep in eeps:
        ave_eeps.append(eep.mean(axis=2, keepdims=False))
    names_ave = save_eeps_npz(cwd, ave_eeps, postbase="_ave")

    return [*names_npy, *names_npz, *names_ave]


def remove_eeps(names: list[str]) -> None:
    """Remove EEPs generated by save_eeps."""
    for fname in names:
        os.remove(fname)


class TestEeps:
    """Class to hold tests of EEPs."""

    @pytest.fixture(autouse=True)
    def create_eeps(self):
        """Fixture to setup and teardown test data."""
        # EEPs are complex with regular sampling (resolution res) in az,za
        # for each antenna
        self.nantenna = 6  # pylint: disable=attribute-defined-outside-init
        self.res = 15  # pylint: disable=attribute-defined-outside-init
        azimuth = numpy.linspace(0.0, 360.0, num=int(360 / self.res) + 1, endpoint=True)
        z_angle = numpy.linspace(0.0, 90.0, num=int(90 / self.res) + 1, endpoint=True)
        azimuth *= numpy.pi / 180.0
        z_angle *= numpy.pi / 180.0
        eep_shape = (len(azimuth), len(z_angle), self.nantenna)

        # convert azimuth from the EEP N-from-E def to a standard E-from-N bearing.
        bearing = numpy.pi / 2 - azimuth

        az, za = numpy.meshgrid(
            bearing,
            z_angle,
            indexing="ij",
        )

        numpy.random.seed(seed=10000000)
        eep_x_phi = (-numpy.cos(az))[:, :, None] * numpy.exp(
            1j * random.normal(0, 0.1, eep_shape)
        )
        eep_x_theta = (-numpy.cos(za) * numpy.sin(az))[:, :, None] * numpy.exp(
            1j * random.normal(0, 0.1, eep_shape)
        )
        eep_y_phi = (numpy.sin(az))[:, :, None] * numpy.exp(
            1j * random.normal(0, 0.1, eep_shape)
        )
        eep_y_theta = (-numpy.cos(za) * numpy.cos(az))[:, :, None] * numpy.exp(
            1j * random.normal(0, 0.1, eep_shape)
        )
        assert eep_x_phi.dtype == numpy.complex128

        # pylint: disable-next=attribute-defined-outside-init
        self.eeps = [eep_x_phi, eep_x_theta, eep_y_phi, eep_y_theta]
        names = save_eeps(self.eeps)

        yield

        remove_eeps(names)

    def test_get_nearest_file(self) -> None:
        """Test the load of EEPs in npy format."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        freq = 115.4
        freq_str = get_nearest_file(f"{cwd}/../testing_data/tmp_*_Xpol_phi.npy", freq)
        assert float(freq_str) == 120

    def test_load_eeps(self) -> None:
        """Test the load of EEPs in npy format."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        freq = 115.4

        # Load in the truth. Also conjugate, since that happens by default in load_eeps
        eep_x_phi, eep_x_theta, eep_y_phi, eep_y_theta = self.eeps
        eep_x_phi = eep_x_phi.conj()
        eep_x_theta = eep_x_theta.conj()
        eep_y_phi = eep_y_phi.conj()
        eep_y_theta = eep_y_theta.conj()

        freq_str = get_nearest_file(f"{cwd}/../testing_data/tmp_*_Xpol_phi.npy", freq)
        assert float(freq_str) == 120

        eeps = load_eeps(freq, path=f"{cwd}/../testing_data", filebase="tmp_")
        assert eeps[0].dtype == numpy.complex64
        assert 360.0 / (eeps[0].shape[0] - 1) == self.res
        assert 90.0 / (eeps[0].shape[1] - 1) == self.res

        assert numpy.allclose(eeps[0], eep_x_phi, atol=1e-7)
        assert numpy.allclose(eeps[1], eep_x_theta, atol=1e-7)
        assert numpy.allclose(eeps[2], eep_y_phi, atol=1e-7)
        assert numpy.allclose(eeps[3], eep_y_theta, atol=1e-7)

        eeps = load_eeps(
            freq, path=f"{cwd}/../testing_data", filebase="tmp_", conjugate=False
        )
        assert numpy.allclose(eeps[0], eep_x_phi.conj(), atol=1e-7)
        assert numpy.allclose(eeps[1], eep_x_theta.conj(), atol=1e-7)
        assert numpy.allclose(eeps[2], eep_y_phi.conj(), atol=1e-7)
        assert numpy.allclose(eeps[3], eep_y_theta.conj(), atol=1e-7)

        eeps = load_eeps(
            freq, path=f"{cwd}/../testing_data", filebase="tmp_", suffix=".npz"
        )

        assert eeps[0].dtype == numpy.complex64
        assert 360.0 / (eeps[0].shape[0] - 1) == self.res
        assert 90.0 / (eeps[0].shape[1] - 1) == self.res

        assert numpy.allclose(eeps[0], eep_x_phi, atol=1e-7)
        assert numpy.allclose(eeps[1], eep_x_theta, atol=1e-7)
        assert numpy.allclose(eeps[2], eep_y_phi, atol=1e-7)
        assert numpy.allclose(eeps[3], eep_y_theta, atol=1e-7)

        eeps = load_eeps(
            freq, path=f"{cwd}/../testing_data", filebase="tmp_ave_", suffix=".npz"
        )
        assert eeps[0].ndim == 3
        assert eeps[0].shape[2] == 1

        assert eeps[0].dtype == numpy.complex64
        assert 360.0 / (eeps[0].shape[0] - 1) == self.res
        assert 90.0 / (eeps[0].shape[1] - 1) == self.res

        assert numpy.allclose(eeps[0], eep_x_phi.mean(axis=2, keepdims=True), atol=1e-7)
        assert numpy.allclose(
            eeps[1], eep_x_theta.mean(axis=2, keepdims=True), atol=1e-7
        )
        assert numpy.allclose(eeps[2], eep_y_phi.mean(axis=2, keepdims=True), atol=1e-7)
        assert numpy.allclose(
            eeps[3], eep_y_theta.mean(axis=2, keepdims=True), atol=1e-7
        )

    def test_resample_eeps(self) -> None:
        """Test the resampling and normalisation of EEPs."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        freq = 115.4
        freq_str = get_nearest_file(f"{cwd}/../testing_data/tmp_*_Xpol_phi.npy", freq)
        assert float(freq_str) == 120
        eeps = load_eeps(freq, path=f"{cwd}/../testing_data", filebase="tmp_")
        azimuth_deg = [0.0, 0.0, 0.0]
        elevation_deg = [60.0, 75.0, 90.0]
        eeps_lsm = resample_eeps(eeps, 0.0, azimuth_deg, elevation_deg)
        assert len(eeps_lsm) == len(eeps)
        assert eeps_lsm[0].shape == (eeps[0].shape[2], len(azimuth_deg))

        ave_eeps = load_eeps(
            freq, path=f"{cwd}/../testing_data", filebase="tmp_ave_", suffix=".npz"
        )
        ave_eeps_lsm = resample_eeps(ave_eeps, 0.0, azimuth_deg, elevation_deg)
        assert numpy.allclose(ave_eeps_lsm[0][0], eeps_lsm[0].mean(axis=0), atol=1e-7)
        assert numpy.allclose(ave_eeps_lsm[1][0], eeps_lsm[1].mean(axis=0), atol=1e-7)
        assert numpy.allclose(ave_eeps_lsm[2][0], eeps_lsm[2].mean(axis=0), atol=1e-7)
        assert numpy.allclose(ave_eeps_lsm[3][0], eeps_lsm[3].mean(axis=0), atol=1e-7)

    def test_normalise_eeps(self) -> None:
        """Test the resampling and normalisation of EEPs."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        freq = 115.4
        freq_str = get_nearest_file(f"{cwd}/../testing_data/tmp_*_Xpol_phi.npy", freq)
        assert float(freq_str) == 120
        eeps = load_eeps(freq, path=f"{cwd}/../testing_data", filebase="tmp_")
        azimuth_deg = [0.0, 0.0, 0.0]
        elevation_deg = [60.0, 75.0, 90.0]
        eeps_lsm = resample_eeps(eeps, 0.0, azimuth_deg, elevation_deg)
        eeps_lsm = normalise_eeps(eeps_lsm)
        assert len(eeps_lsm) == len(eeps)
        assert numpy.allclose(
            numpy.sum(numpy.abs(eeps_lsm[0]) ** 2, axis=1), 1, atol=1e-6
        )
        assert numpy.allclose(
            numpy.sum(numpy.abs(eeps_lsm[1]) ** 2, axis=1), 0, atol=1e-6
        )
        assert numpy.allclose(
            numpy.sum(numpy.abs(eeps_lsm[2]) ** 2, axis=1), 0, atol=1e-6
        )
        assert numpy.allclose(
            numpy.sum(numpy.abs(eeps_lsm[3]) ** 2, axis=1), 1, atol=1e-6
        )

    def test_rotate_eeps(self) -> None:  # pylint: disable=too-many-locals
        """Test EEP resampling with different rotations."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        raw_eeps = load_eeps(115.4, path=f"{cwd}/../testing_data", filebase="tmp_")
        # sky pixels to sample
        naz = 24
        nel = 9
        azimuth_deg, elevation_deg = numpy.meshgrid(
            numpy.arange(0, 360, 360 / naz), numpy.arange(0, 90, 90 / nel)
        )
        azimuth_deg = azimuth_deg.flatten()
        elevation_deg = elevation_deg.flatten()
        # resample with three different EEP rotations
        eeps000 = resample_eeps(raw_eeps, 0, azimuth_deg, elevation_deg)
        eeps090 = resample_eeps(raw_eeps, 90, azimuth_deg, elevation_deg)
        eeps180 = resample_eeps(raw_eeps, 180, azimuth_deg, elevation_deg)
        # ensure that rotated patterns are equal
        iaz = numpy.arange(naz)
        assert len(eeps000) == 4
        for pol in range(4):
            assert eeps000[pol].shape[0] == self.nantenna
            for stn in range(eeps000[pol].shape[0]):
                p000 = eeps000[pol][stn].reshape(nel, naz)
                p090 = eeps090[pol][stn].reshape(nel, naz)
                p180 = eeps180[pol][stn].reshape(nel, naz)
                assert numpy.allclose(p000, p090[:, (naz // 4 + iaz) % naz], atol=1e-7)
                assert numpy.allclose(p000, p180[:, (naz // 2 + iaz) % naz], atol=1e-7)

    def test_back_rotation(self) -> None:
        """Test back rotation of solutions for stations with different rotations."""
        cwd = os.path.dirname(os.path.realpath(__file__))
        raw_eeps = load_eeps(115.4, path=f"{cwd}/../testing_data", filebase="tmp_")
        # direction of interest
        azimuth_deg = [130]
        elevation_deg = [65]
        # resample with two different EEP rotations
        rotation1_deg = 30
        eeps1 = resample_eeps(raw_eeps, rotation1_deg, azimuth_deg, elevation_deg)
        eeps1 = normalise_eeps(eeps1)
        rotation2_deg = 75
        eeps2 = resample_eeps(raw_eeps, rotation2_deg, azimuth_deg, elevation_deg)
        eeps2 = normalise_eeps(eeps2)
        # average EEPs over stations into "beams" and cross-correlate with back rotation
        assert len(eeps1) == 4
        assert len(eeps2) == 4
        beam1 = numpy.mean(
            numpy.array(eeps1).T.reshape(  # pylint: disable=too-many-function-args
                -1, 2, 2
            ),
            axis=0,
        )
        beam2 = numpy.mean(
            numpy.array(eeps2).T.reshape(  # pylint: disable=too-many-function-args
                -1, 2, 2
            ),
            axis=0,
        )

        # there are no cal errors, so gains = eye(2) @ station_rotation_matrix(rotation)

        back1 = numpy.linalg.inv(station_rotation_matrix(rotation1_deg)) @ beam1
        back2 = numpy.linalg.inv(station_rotation_matrix(rotation2_deg)) @ beam2

        beam12 = beam1 @ beam2.conj().T
        back12 = back1 @ back2.conj().T

        assert max([numpy.abs(beam12[0, 1]), numpy.abs(beam12[0, 1])]) > 0.5
        assert max([numpy.abs(back12[0, 1]), numpy.abs(back12[0, 1])]) < 0.1
